require 'sketchup.rb'
def clean_selection(entities)
	trash = []
	Sketchup.active_model.start_operation "Clean Selection"
	selection = Sketchup.active_model.selection
	if (entities)
		selection.clear
		selection.add entities
	end
	selection.each {|looptemp|trash.push(looptemp) if (looptemp.typename == "Edge" && looptemp.faces.length == 0)}
	selection.each {|looptemp|trash.push(looptemp) if (looptemp.typename == "Edge" && looptemp.faces.length == 2 && looptemp.faces[0].material == looptemp.faces[1].material && (looptemp.faces[0].plane == looptemp.faces[1].plane))}
	Sketchup.active_model.entities.erase_entities(trash)
	Sketchup.active_model.commit_operation
	return
end
def connect_rails(leftpoints, rightpoints, reverse)
	rightnext = nil
	leftnext = nil
	forepoint = nil
	backpoints = []
	thesefaces = []
	leftpoint = leftpoints.shift
	leftnext = leftpoints.shift
	rightpoints.reverse! if ((rightpoints.first.position.distance(leftpoint) > rightpoints.last.position.distance(leftpoint) && reverse == nil) || reverse == true)
	rightpoint = rightpoints.shift
	rightnext = rightpoints.shift
	while (true)
		backpoints = [leftpoint, rightpoint]
		leftnext = leftpoints.shift if (leftnext == nil)
		rightnext = rightpoints.shift if (rightnext == nil)
		if ([leftnext, rightnext] == [nil, nil])
			return thesefaces
		elsif (leftnext == nil || (rightnext != nil && rightnext.position.distance(leftpoint) < leftnext.position.distance(rightpoint)))
			forepoint = rightnext
			rightpoint = rightnext
			rightnext = nil
		elsif (leftnext != nil)
			forepoint = leftnext
			leftpoint = leftnext
			leftnext = nil
		end
		thesefaces.push(Sketchup.active_model.entities.add_face([backpoints, forepoint].flatten))
	end
end
def get_points(startpoint, lines)
	points = [startpoint]
	points.push (((lines.delete((points.last.edges & lines)[0])).vertices.reject{|looptemp|looptemp == points.last})[0]) while ((points.last.edges & lines).length != 0)
	return(points)
end
def skin
	strings = ["An error occurred. The next version will hopefully fix the one that you are experiencing. Version 3.0 is the next planned errorless one.",
		"You must have selected more than you wanted to, it is not all in two groups. Currently I'm taking two random ones but future versions will deal differently with this issue",
		"Is this connection done right?",
		"Do you want to try to guide me to the correct connection?",
		"Shall I try to fix my error?"]
	selection = Sketchup.active_model.selection
	section = []
	reverse = nil
	connecttype = nil
	side = []
	sides = []
	connectionfaces = []
	sidesets = []
	allfaces = []
	sidefaces = []
	alledges = []
	rightedges = []
	leftedges = []
	leftpoints = []
	rightpoints = []
	prepedpoints = []
	intersections = []
	ends = []
	selection.each {|looptemp| alledges.push(looptemp)}
	sidefaces = alledges.reject{|looptemp| looptemp.typename != "Face"}
	allfaces = sidefaces
	alledges.reject!{|looptemp| looptemp.typename != "Edge"}
	while (alledges.length > 0)
		side.push(alledges.pop)
		side.each do
			|looptemp|
			looptemp.vertices.each do
				|loopt|
				(loopt.edges & alledges).each do
					|lpt|
					side.push lpt
					alledges.delete lpt
				end
			end
		end
		sides.push(side + [])
		side.clear
	end
	UI.messagebox strings[1] if (sides.length > 2)
	sidesets.push([sides[0], sides[1], sidefaces])
	Sketchup.active_model.start_operation "Skin"
	sidesets.each do
		|set|
		rightedges = set[0]
		leftedges = set[1]
		sidefaces = set[2]
		rightpoints = rightedges.collect{|looptemp| looptemp.vertices}.flatten.uniq
		leftpoints = leftedges.collect{|looptemp| looptemp.vertices}.flatten.uniq
		intersections = (rightpoints + leftpoints).reject{|looptemp|(looptemp.edges & (rightedges + leftedges)).length < 3}
		ends = (rightpoints + leftpoints).reject{|looptemp|(looptemp.edges & (rightedges + leftedges)).length != 1}
		if (intersections.length > 0)
			UI.messagebox strings[0]
			connecttype = 3
		elsif (ends.length == 0)
			leftpoints = get_points(leftpoints.sort{|a,b|a.position.distance(rightpoints.first) <=> b.position.distance(rightpoints.first)}[0], Array.new(leftedges))
			rightpoints = get_points(rightpoints.first, Array.new(rightedges))
			connectionfaces.push(connect_rails(leftpoints, rightpoints, reverse))
			connecttype = 4
		elsif ([(leftpoints & ends).length, (rightpoints & ends).length] == [2, 2])
			leftpoints = get_points((leftpoints & ends)[0], Array.new(leftedges))
			rightpoints = get_points((rightpoints & ends)[0], Array.new(rightedges))
			connectionfaces.push(connect_rails(leftpoints, rightpoints, reverse))
			connecttype = 4
		else
			UI.messagebox strings[0]
			connecttype = 4
		end
		if (reverse != false && UI.messagebox(strings[2], MB_YESNO, "Quality Check") == 7 && UI.messagebox(strings[connecttype], MB_YESNO, "Answer, Please") == 6)
			connectionfaces.flatten!
			connectionfaces.push(connectionfaces.collect{|looptemp| looptemp.edges})
			connectionfaces.flatten!
			connectionfaces = connectionfaces - (leftedges + rightedges)
			Sketchup.active_model.entities.erase_entities(connectionfaces.flatten)
			connectionfaces.clear
			reverse = false if reverse == true
			reverse = true if reverse == nil
			redo
		end
		allfaces.push connectionfaces
	end
	allfaces.flatten!
	allfaces.collect!{|looptemp| [looptemp.edges, looptemp]}
	allfaces.flatten!
	allfaces.uniq
	clean_selection allfaces
	Sketchup.active_model.commit_operation
	return true
end
skin = SketchupExtension.new "Skin", "skin.rb"
skin.description = "A tool that takes two selected sets of entities and connects them, normally..."
skin.version = "2.1"
skin.creator = "Darrel Belvin, Toolbar Icons were done by Baz"
skin.copyright = "2007, Darrel Belvin"
skinc = UI::Command.new("Skin") {skin()}
skinc.small_icon = "skin/skinS.png"
skinc.large_icon = "skin/skin.png"
skinc.tooltip = "Connects the two selected sides."
cleanc = UI::Command.new("Clean") {clean_selection(nil)}
cleanc.small_icon = "skin/cleanS.png"
cleanc.large_icon = "skin/clean.png"
cleanc.tooltip = "Removes all coplanar or empty selected edges."
if not (file_loaded? "skin.rb")
	add_separator_to_menu("Tools")
	dbtoolsm = UI.menu("Tools").add_submenu("D.B.Tools")
		dbtoolsm.add_item("Clean Selection") {clean_selection(nil)}
		dbtoolsm.add_item("Skin") {skin()}
	Sketchup.register_extension skin
	DBTools = UI::Toolbar.new("D.B. Tools")
	DBTools.add_item(skinc)
	DBTools.add_item(cleanc)
end
file_loaded("skin.rb")